#include "StdAfx.h"
#include "DrawOnlyHandler.h"
#include "DrawAndMouseHandler.h"
#include "TutorialApp.h"


void CDrawAndMouseHandler::OnMouseButton(bool down, unsigned int nFlags, int hwX, int hwY)
{
  int deviceX, deviceY;
  HardwareToDevice(hwX, hwY, deviceX, deviceY);
  CString msg;

  // if(nFlags & MK_CONTROL) key = "[CTRL]";
  // if(nFlags & MK_SHIFT)   key += "[SHIFT]";

  if (down)
  {
    if(nFlags & MK_LBUTTON) 
    {
      //left button was pressed of released
      m_Camera.BeginMouseRotate(deviceX, deviceY);
      msg.Format(L"Begin Camera Rotation: (%d %d)", deviceX, deviceY);
    }
    else if(nFlags & MK_MBUTTON)
    {
      //right button was pressed or released
      m_Camera.BeginMouseTrack(deviceX, deviceY);
      msg.Format(L"Begin Camera Tracking: (%d %d)", deviceX, deviceY);
    }
    else if(nFlags & MK_RBUTTON)
    {
      m_Camera.BeginMouseZoom(deviceX);
      msg.Format(L"Begin Camera Zooming: (%d)", deviceX);
    } 
  }
  UWB_EchoToStatusArea(msg);
}

void CDrawAndMouseHandler::OnMouseMove(unsigned int nFlags, int hwX, int hwY)
{
  // if(nFlags & MK_CONTROL) key = "[CTRL]";
  // if(nFlags & MK_SHIFT)   key += "[SHIFT]";
  int deviceX, deviceY;
  HardwareToDevice(hwX, hwY, deviceX, deviceY);
  CString msg;

  if(nFlags & MK_LBUTTON)
  {
    m_Camera.MouseRotate(deviceX, deviceY);
    msg.Format(L"Camera Rotation To: (%d %d)", deviceX, deviceY);
  }
  else if(nFlags & MK_MBUTTON)
  {
    m_Camera.MouseTrack(deviceX, deviceY);
    msg.Format(L"Camera Tracking To: (%d %d)", deviceX, deviceY);
  }
  else if(nFlags & MK_RBUTTON)
  {
    m_Camera.MouseZoom(deviceX);
    msg.Format(L"Camera Zoom: (%d)", deviceX);
  }
  UWB_EchoToStatusArea(msg);
}