#include "StdAfx.h"
#include "DrawOnlyHandler.h"
#include "TutorialApp.h"

CDrawOnlyHandler::CDrawOnlyHandler()
{
  m_Camera.SetCameraPosition(0, 10, -25);
  m_Camera.SetCameraLookAt(0, 0, 0);
  m_Camera.SetCameraUpVector(0, 1, 0);
  m_Camera.SetViewVolumeFarPlane(50.0f);
  m_Camera.SetViewVolumeNearPlane(1.0f);
  m_Camera.SetViewVolumeFOVInDegree(45.0f);

  m_Z = 0.0f;
}

bool CDrawOnlyHandler::Initialize(CDialog& parent_dlg, int control_id)
{
  if( !m_window.ReplaceDialogControl(parent_dlg.m_hWnd, control_id) )
    return false;

  if( !m_window.AttachHandler(this) )
    return false;

  return true;
}

void CDrawOnlyHandler::DrawGraphics()
{
  if(NULL == m_pD3DDevice)
    return;

  BeginDraw();

  LoadViewXform();
  LoadProjectionXform();

  // Set the model matrix to identity
  D3DXMATRIX identity;
  D3DXMatrixIdentity(&identity);
  m_pD3DDevice->SetTransform( D3DTS_WORLD, &identity);

  //clear the draw buffer to light gray
  D3DCOLOR background = D3DCOLOR_COLORVALUE(0.8f, 0.8f, 0.8f, 0);
  m_pD3DDevice->Clear(0,                // number of rectangles, 0 means the entire area
                      NULL,             // rectangles to be cleared, NULL means the entire area
                      D3DCLEAR_TARGET|  // clear target (color) 
                      D3DCLEAR_ZBUFFER, // and clear z-buffer
                      background,// new color to clear to
                      1.0f,             // new Z values to clear to
                      0);               // new Stencil buffer values to clear to

  //perform all of our drawing
  theApp.GetModel().DrawModel();

// m_pD3DDevice->SetRenderState(D3DRS_ZENABLE,	D3DZB_FALSE);

m_pD3DDevice->SetTransform(D3DTS_WORLD, &identity);
m_pD3DDevice->SetTransform(D3DTS_VIEW, &identity);
m_pD3DDevice->SetTransform(D3DTS_PROJECTION, &identity);
UWB_PrimitiveRectangleXY r;

r.SetCorners(vec3(-0.8, -0.8, m_Z), vec3(0.8f, 0.8f, m_Z));
r.EnableBlending(true);
r.SetFlatColor(UWB_Color(0.2, 1.0, 0.2, 0.5));

UWBD3D_DrawHelper dh;
r.Draw(dh.GetLOD(), dh);


  m_pD3DDevice->SetRenderState( D3DRS_ZENABLE,	D3DZB_TRUE);
  EndDrawAndShow();
}
