// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once

/// Class with specific duty of drawing Direct3D graphics to an attached window
/// This implementation contains a member that represents that actual window
class CDrawOnlyHandler : public UWBD3D_WindowHandler 
{
public:
  CDrawOnlyHandler();

  /// Used to place the graphics window on a parent dialog
  /// \param parent_dlg The dialog to place the window on
  /// \param control_id ID for placeholder on dialog to replace with the graphics window
  /// \return true on success
  bool Initialize(CDialog& parent_dlg, int control_id);

  ///
  /// virtual function for drawing the actual graphics
  void DrawGraphics();

  void SetZ(float z) { m_Z = z; }

protected:
  UWBMFC_UIWindow m_window;
  float m_Z;
};
