#include "uwbgl_Camera3.h"

UWB_Camera::UWB_Camera()
:m_CameraPos(0, 0, -1)
,m_LookAt(0, 0, 0)
,m_UpVector(0, 1, 0)
,m_ViewFOV(45.0f)
,m_ViewNearPlane(0.1f)
,m_ViewFarPlane(100.0f)
,m_XRotStart(0.0f)
,m_YRotStart(0.0f)
,m_XRot(0.0f)
,m_YRot(0.0f)
,m_TmpInitXPos(0)
,m_TmpInitYPos(0)
{
}

void UWB_Camera::SetViewFrustumInDegree(float v, float n, float f)
{
  m_ViewFOV = v;
  m_ViewNearPlane = n;
  m_ViewFarPlane = f;
}

void UWB_Camera::GetViewFrustumInDegree(float &v, float &n, float &f) const
{
  v = m_ViewFOV;
  n = m_ViewNearPlane;
  f = m_ViewFarPlane;
}

void UWB_Camera::SetCameraPosition(float x, float y, float z)
{
  SetCameraPosition( vec3(x,y,z) );
}

void UWB_Camera::SetCameraPosition(vec3 v)
{
  m_CameraPos = v;
}

vec3 UWB_Camera::GetCameraPosition() const
{
  return m_CameraPos;
}

void UWB_Camera::SetCameraLookAt( float x, float y, float z )
{
  SetCameraLookAt( vec3(x,y,z) );
}

void UWB_Camera::SetCameraLookAt(vec3 v)
{
  m_LookAt = v;
}

vec3 UWB_Camera::GetCameraLookAt() const
{
  return m_LookAt;
}

void UWB_Camera::SetCameraUpVector(float x, float y, float z)
{
  SetCameraUpVector( vec3(x,y,z) );
}

void UWB_Camera::SetCameraUpVector( vec3 v )
{
  m_UpVector = v;
}

vec3 UWB_Camera::GetCameraUpVector() const
{
  return m_UpVector;
}


float UWB_Camera::GetViewVolumeFOVInRadian() const
{
  return UWB_ToRadians(m_ViewFOV);
}


float UWB_Camera::GetViewVolumeFOVInDegree() const
{
  return m_ViewFOV;
}

void UWB_Camera::SetViewVolumeFOVInDegree(float f)
{
    m_ViewFOV = f;
}

float UWB_Camera::GetViewVolumeNearPlane() const
{
  return m_ViewNearPlane;
}

void UWB_Camera::SetViewVolumeNearPlane(float n) 
{
  m_ViewNearPlane = n;
}


float UWB_Camera::GetViewVolumeFarPlane() const
{
  return m_ViewFarPlane;
}

void UWB_Camera::SetViewVolumeFarPlane(float f)
{
  m_ViewFarPlane = f;
}