// UW Bothell Graphics Library Copyright (c) 2006 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

/// uwbgl_D3D_Lib18.h - Main Include file for version 18 of the UWB Direct3D Graphics Library
/// Include this single header file in your projects to add support for the library.

/// NOTE: There is absolutely no library specific windowing functionality in this library
///       Include the MFC UWBGL library (or other UWBGL windowing library) into your projects
///       to add windowing support.

/// *IMPORTANT*: Header and source files in UWBGL_Direct3D_1 should NEVER include this file.
/// *IMPORTANT*: External projects that use this library should ONLY include this file to get
///              access to all class and functions provided by this library.
#pragma once

#include "uwbgl_D3DDefines.h"       //Direct3D Specific headers and linking instructions

#include "math3d++/math3d++.h"      // math library
using namespace math3d;

#include "uwbgl_Common.h"             //Common headers, symbols, and macros
#include "uwbgl_Containers.h"
#include "uwbgl_IWindowHandler.h"     //Connection to a window
#include "uwbgl_WindowHandler7.h"
#include "uwbgl_Utility2.h"           //Utility functions
#include "uwbgl_Color1.h"
#include "uwbgl_Clock.h"

#include "uwbgl_DrawHelper5.h"

#include "uwbgl_D3DGraphicsSystem7.h" //D3D Graphics System Manager
#include "uwbgl_D3DWindowHandler9.h"  //Generic D3D Window base class
#include "uwbgl_D3DDrawHelper9.h"

#include "uwbgl_Intersect5.h"
#include "uwbgl_XformInfo6.h"
#include "uwbgl_SceneNode7.h"
#include "uwbgl_Camera3.h"

//geometry
#include "uwbgl_Primitive6.h"
#include "uwbgl_PrimitiveCircle6.h"
#include "uwbgl_PrimitiveLine6.h"
#include "uwbgl_PrimitivePoint6.h"
#include "uwbgl_PrimitiveList5.h"
#include "uwbgl_PrimitiveRectXY5.h"
#include "uwbgl_PrimitiveRectXZ3.h"
#include "uwbgl_PrimitiveAxisFrame3.h"

#include "uwbgl_D3DPrimitiveMesh3.h"
#include "uwbgl_D3DPrimitiveMeshAxis4.h"
#include "uwbgl_D3DPrimitiveMeshArrow4.h"
#include "uwbgl_D3DPrimitiveMeshCustom1.h"

// Light and Material
#include "uwbgl_Material1.h"
#include "uwbgl_D3DLight1.h"
#include "uwbgl_D3DDirectionalLight1.h"
#include "uwbgl_D3DPointLight1.h"
#include "uwbgl_D3DSpotLight1.h"
