// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_Primitive6.h"

///
/// An x-y-z axis frame that can be drawn at a given size
class UWB_PrimitiveAxisFrame : public UWB_Primitive
{
public:
  ///
  /// Initialize the instance with a size of 1 unit
  UWB_PrimitiveAxisFrame();

  void SetSize( float size );
  float GetSize() const;
protected:
  void DrawPrimitive( eLevelOfDetail lod, UWB_DrawHelper& draw_helper );
  void SetupDrawAttributes(UWB_DrawHelper& draw_helper);

protected:
  float m_size;
};
